// drView.cpp : implementation of the CDrView class
//

#include "stdafx.h"
#include "dr.h"

#include "drDoc.h"
#include "drView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrView

IMPLEMENT_DYNCREATE(CDrView, CView)

BEGIN_MESSAGE_MAP(CDrView, CView)
	//{{AFX_MSG_MAP(CDrView)
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrView construction/destruction

CDrView::CDrView()
{
	// TODO: add construction code here

}

CDrView::~CDrView()
{
}

BOOL CDrView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDrView drawing

void CDrView::OnDraw(CDC* pDC)
{
	CDrDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// MG: Draw the line segments
	bool StartLine=false;
	CPoint Tmp;
	for( int i=0; i < pDoc->Points.GetSize(); i++ )
	{
		Tmp = pDoc->Points.GetAt(i);
		if( Tmp.x==-1 ) // MG: Start of line flag?
			StartLine = true;
		else
		{
			if( StartLine )
			{
				pDC->MoveTo( Tmp.x, Tmp.y );
				StartLine = false;
			}
			else
				pDC->LineTo( Tmp.x, Tmp.y );
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrView printing

BOOL CDrView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDrView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDrView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDrView diagnostics

#ifdef _DEBUG
void CDrView::AssertValid() const
{
	CView::AssertValid();
}

void CDrView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDrDoc* CDrView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrDoc)));
	return (CDrDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrView message handlers

void CDrView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// MG: Store final point
	MouseDown = false;
	CDrDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->Points.Add( point );
	
	CView::OnLButtonUp(nFlags, point);
}

void CDrView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// MG: Start a line segment
	MouseDown = true;
	CDrDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->Points.Add( CPoint(-1,-1) );	// MG: 'start line' flag
	pDoc->Points.Add( point );
	pDoc->SetModifiedFlag( TRUE );

	CView::OnLButtonDown(nFlags, point);
}

void CDrView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// MG: Make sure mouse was, and stil is, down, while moving
	if( nFlags&MK_LBUTTON && MouseDown)
	{
		CDrDoc* pDoc = GetDocument();	// MG: If so, store new point...
		ASSERT_VALID(pDoc);

		pDoc->Points.Add( point );
		CClientDC Tmp(this);	// MG: And draw all the points again, temp DC
		OnDraw( &Tmp );
	}
	else
		MouseDown = false;

	CView::OnMouseMove(nFlags, point);
}
